- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# InvertibleRWFunction Class Reference

`#include <rw.h>`

Inheritance diagram for InvertibleRWFunction:

List of all members.

## Detailed Description

_

Definition at line 41 of file rw.h.

## Public Member Functions
void | Initialize (const Integer &n, const Integer &p, const Integer &q, const Integer &u)
void | Initialize (RandomNumberGenerator &rng, unsigned int modulusBits)
void | BERDecode (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
Integer | CalculateInverse (RandomNumberGenerator &rng, const Integer &x) const
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
void | AssignFrom (const NameValuePairs &source)
| assign values from source to this object
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
const Integer & | GetPrime1 () const
const Integer & | GetPrime2 () const
const Integer & | GetMultiplicativeInverseOfPrime2ModPrime1 () const
void | SetPrime1 (const Integer &p)
void | SetPrime2 (const Integer &q)
void | SetMultiplicativeInverseOfPrime2ModPrime1 (const Integer &u)
void | Initialize (const Integer &n)
Integer | ApplyFunction (const Integer &x) const
Integer | PreimageBound () const
Integer | ImageBound () const
const Integer & | GetModulus () const
void | SetModulus (const Integer &n)
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
bool | IsRandomized () const
virtual Integer | MaxPreimage () const
virtual Integer | MaxImage () const
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
virtual void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
virtual void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
virtual bool | SupportsPrecomputation () const
| Returns: whether this object supports precomputation
virtual void | Precompute (unsigned int n)
| do precomputation
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
void | DoQuickSanityCheck () const
template<class T>
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T>
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T>
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
Integer | CalculateRandomizedInverse (RandomNumberGenerator &rng, const Integer &x) const
bool | IsRandomized () const
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| calls the above function with a NameValuePairs object that just specifies "KeySize"
## Static Public Member Functions
static void __cdecl | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch
## Protected Attributes
Integer | m_p
Integer | m_q
Integer | m_u
Integer | m_n

## Member Function Documentation

bool InvertibleRWFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level |
| ) |  |  | const`[virtual]`

check this object for errors

Parameters:

  | level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time

Returns:
  true if the tests pass

Reimplemented from RWFunction.

Definition at line 160 of file rw.cpp.

References Integer::IsPositive(), RWFunction::m_n, m_p, m_q, m_u, Integer::One(), and RWFunction::Validate().

void InvertibleRWFunction::AssignFrom | ( | const NameValuePairs & | source | ) | `[virtual]`

assign values from source to this object

Note:
  This function can be used to create a public key from a private key.

Reimplemented from RWFunction.

Definition at line 185 of file rw.cpp.

void InvertibleRWFunction::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg |
| ) |  |  | `[virtual]`

parameters: (ModulusSize)

Reimplemented from GeneratableCryptoMaterial.

Definition at line 88 of file rw.cpp.

References Integer::GenerateRandom(), NameValuePairs::GetIntValue(), Integer::InverseMod(), RWFunction::m_n, m_p, m_q, and m_u.

virtual void CryptoMaterial::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

load key from a BufferedTransformation

Exceptions:

  | KeyingErr | if decode fails

Note:
  Generally does not check that the key is valid. Call ValidateKey() or ThrowIfInvalidKey() to check that.

Reimplemented in InvertibleRSAFunction, ASN1CryptoMaterial< PrivateKey >, ASN1CryptoMaterial< DL_GroupParameters< Integer > >, and ASN1CryptoMaterial< PublicKey >.

Definition at line 1025 of file cryptlib.h.

virtual void CryptoMaterial::Precompute | ( | unsigned int | n | ) | `[inline, virtual, inherited]`

do precomputation

The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation.

Reimplemented in DL_GroupParameters< T >, DL_PrivateKeyImpl< GP >, DL_PublicKeyImpl< GP >, DL_GroupParameters< Integer >, DL_GroupParameters< typenameEcPrecomputation< EC >::Element >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, and DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >.

Definition at line 1034 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value |
| ) |  |  | const`[inline, inherited]`

get a named value with type int

used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case)

Definition at line 280 of file cryptlib.h.

Referenced by GenerateRandom(), InvertibleRSAFunction::GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), DL_GroupParameters_IntegerBased::GenerateRandom(), DL_GroupParameters_DSA::GenerateRandom(), InvertibleESIGNFunction::GenerateRandom(), and Integer::GenerateRandomNoThrow().

The documentation for this class was generated from the following files:

- rw.h
- rw.cpp